// Copyright ram-0000
// Je donne mon accord  Developpez.com pour une ventuelle intgration dans les pages Sources du site.

#define _CRT_SECURE_NO_WARNINGS

/*
#ifndef _WIN32_WINNT		// Autorise l'utilisation des fonctionnalits spcifiques  WindowsXP ou version ultrieure.                   
#define _WIN32_WINNT 0x0501	// Attribuez la valeur approprie  cet lment pour cibler d'autres versions de Windows.
#endif
*/
#include "ListGrille.h"
#include "Logger.h"
#include "MyTimer.h"
#include <string>

void LectureFichier(CLogger & Log, const char * FileName, CGrille & GrilleInitial);
bool check(const std::vector<std::string> & array_ligne, const int x, const int y, bool & vertical);

int main(int argc, char * argv [])
{
	CLogger Log;

	// lance un timer pour calculer le temps
	CMyTimer timer;
	timer.Start();

	try
    {
        // Options ligne de commande
        if( (argc == 2) && (std::string(argv[1]) == "-v") )
        {
            Log << "Copyright (c) 2009 Raymond\n";
        }
        else if( (argc == 2) && (std::string(argv[1]) == "-h") )
        {
            Log << "Usages :\n";
			Log.Level(1); Log << "AneRouge -h            Affiche l'aide\n";
            Log.Level(1); Log << "AneRouge -v            Affiche le copyright\n";
            Log.Level(1); Log << "AneRouge -f [fichier]  Charge un fichier plateau et recherche une solution\n";
        }
        else if( (argc == 3) && (std::string(argv[1]) == "-f") )
        {
			// lecture du fichier
			CGrille GrilleInitial;
			LectureFichier(Log, argv[2], GrilleInitial);

			// creation de la liste de grilles
			CListGrille m_grille;
			if(m_grille.Generate(Log) == false)
	            throw std::exception("Erreur de gnration des grilles");

			m_grille.DisplayStatGrille(Log, GrilleInitial.GetHash());

			//m_grille.Stat(Log);
        }
        else
        {
            throw std::exception("ligne de commande invalide (essayez '-h' pour obtenir de l'aide)");
        }

	}
    catch(std::exception & e)
    {
        // gestion des erreurs
		Log << "ERREUR ==> " << e.what() << " !\n";
    }

	// affiche le temps d'excution
	timer.StopAndPrint(Log, "Dure totale d'excution");
    return EXIT_SUCCESS;
}

void LectureFichier(CLogger & Log, const char * FileName, CGrille & GrilleInitial)
{
	Log << "Lecture du fichier " << FileName << "...\n";
    std::ifstream fichier(FileName);
	if(fichier.is_open() == false)
        throw std::exception("Impossible d'ouvrir le fichier plateau");

    // 1er tape : lecture des lignes et calcule de la largeur
    std::vector<std::string> array_ligne;
    std::string ligne;
    while(std::getline(fichier, ligne))
    {
		// verifie la largeur de la ligne (doit tre de 4)
		if(ligne.size() != 4)
			throw std::exception("Largeur de ligne invalide");

		// verifie les caractres autoriss
        if(ligne.find_first_not_of("ABCDEFGHIJKL") != std::string::npos)
			throw std::exception("Caractres non autoriss");

		// Ajout de la ligne
        array_ligne.push_back(ligne);
    }
    if(!fichier.eof())
        throw std::exception("Problme lecture disque");

	// verifie le nombre de ligne
	if(array_ligne.size() != 5)
		throw std::exception("Nombre de ligne invalide");

	// creation de la grille initiale
	int case_0 = 0;
	int case_1 = 0;
	int case_2 = 0;
	int case_4 = 0;
	GrilleInitial.Vide();
	for(int y = 0; y != 5; y++)
	{
		for(int x = 0; x != 4; x++)
		{
			switch(array_ligne[y][x])
			{
			case 'A' : case 'B' :
				GrilleInitial.SetVide((y * 4) + x);
				case_0++;
				break;
			case 'C' : case 'D' : case 'E' : case 'F' :
				GrilleInitial.SetPetitCarre((y * 4) + x);
				case_1++;
				break;
			case 'G' : case 'H' : case 'I' : case 'J' : case 'K' :
				bool flag_vertical;
				if(check(array_ligne, x, y, flag_vertical) == false)
					throw std::exception("Configuration invalide");
				case_2++;
				if(flag_vertical == true)
					GrilleInitial.SetRectangleVertical((y * 4) + x);
				else
					GrilleInitial.SetRectangleHorizontal((y * 4) + x);
				break;
			case 'L' :
				GrilleInitial.SetGrosCarre((y * 4) + x);
				case_4++;
				break;
			}
		}
	}

	// verifie la validite de la grille
	//GrilleInitial.Dump(Log);
	if( (case_0 != 2) || (case_1 != 4) || (case_2 != 10) || (case_4 != 4) )
		throw std::exception("Configuration invalide");
}

bool check(const std::vector<std::string> & array_ligne, const int x, const int y, bool & vertical)
{
	// recupere le caractre
	char carac = array_ligne[y][x];

	// verifie en haut
	if( (y > 0) && (array_ligne[y - 1][x] == carac) )
	{
		// en haut, vertical
		vertical = true;
		return true;
	}

	// verifie en bas
	if( (y < 4) && (array_ligne[y + 1][x] == carac) )
	{
		// en bas, vertical
		vertical = true;
		return true;
	}

	// verifie  gauche
	if( (x > 0) && (array_ligne[y][x - 1] == carac) )
	{
		//  gauche, horizontal
		vertical = false;
		return true;
	}

	// verifie  droite
	if( (x < 3) && (array_ligne[y][x + 1] == carac) )
	{
		//  droite, horizontal
		vertical = false;
		return true;
	}

	return false;
}
