// Copyright ram-0000
// Je donne mon accord  Developpez.com pour une ventuelle intgration dans les pages Sources du site.

#ifndef CMOUVEMENT_INCLUDED
#define CMOUVEMENT_INCLUDED

#include <fstream>
#include <vector>

typedef unsigned long long int Hash_t;

class CMouvement
{
public:
	typedef std::vector<CMouvement> ListMouvement_t;

	typedef enum { MoveUp, MoveDown, MoveLeft, MoveRight, } Mouvement_t;

	CMouvement(void);
	CMouvement(const Hash_t HashFrom, const int Pos, const Mouvement_t Mouvement, const Hash_t HashTo);

	inline CMouvement(const CMouvement & Other) { *this = Other; }
	CMouvement & operator = (const CMouvement & Other);

	inline void SetHashFrom(const Hash_t Hash) { m_hash_from = Hash; }
	inline Hash_t GetHashFrom(void) const { return m_hash_from; }

	inline int GetPos(void) const { return m_pos; }

	inline Mouvement_t GetMouvement(void) const { return m_mouvement; }

	inline void SetHashTo(const Hash_t Hash) { m_hash_to = Hash; }
	inline Hash_t GetHashTo(void) const { return m_hash_to; }

	bool Save(std::ofstream & OutputStream) const;
	bool Load(std::ifstream & InputStream);

private:
	Hash_t m_hash_from;
	int m_pos;
	Mouvement_t m_mouvement;
	Hash_t m_hash_to;
};

#endif // #ifndef CMOUVEMENT_INCLUDED